"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ts_simple_ast_1 = require("ts-simple-ast");
class AbsApiClass {
    constructor() {
        this.ast = new ts_simple_ast_1.Project();
    }
    parseElements(elements, element, block, filename) {
        elements.pop();
        this.extractElementContent(element.content);
        const classAst = this.getClassAst({ filePath: this.filePath, className: this.className });
        if (!classAst) {
            return elements;
        }
        const newElements = this.transferToNewElement({ filePath: this.filePath, classAst, prefix: '' });
        return [...elements, ...newElements];
    }
    transferToNewElement({ filePath, classAst, prefix }) {
        const properties = classAst.getProperties();
        let elements;
        // for (const property of properties) {
        //   let typeDef = inttype ? inttype + '.' + prop.getName() : prop.getName()
        //   let descriptionPrefix = inttype ? inttype + ' > ' : ''
        //   let propDocNode = prop.getJsDocs()[0]
        //   let propComment = propDocNode ? propDocNode.getComment() : prop.getName()
        //   let description = descriptionPrefix + propComment
        //   let propType = prop.getType().getText()
        //   let propLabel = propType
        //   let propTypeIsObject = !isNativeType(propType)
        //   if (propTypeIsObject) {
        //     let isArray = propType.includes('[]')
        //     propLabel = 'Object' + (isArray ? '[]' : '')
        //   }
        //   const type = prefix ? `${prefix}.${property.getName()}`
        //   const node = property.getJsDocs()[0]
        // }
        return [];
    }
    extractElementContent(content) {
        let startPos = content.indexOf('(');
        let endPos = content.indexOf(')', startPos);
        this.filePath = content.substring(startPos + 1, endPos);
        startPos = content.indexOf('{', endPos);
        endPos = content.indexOf('}', startPos);
        this.className = content.substring(startPos + 1, endPos);
    }
    getClassAst({ filePath, className }) {
        const file = this.ast.addExistingSourceFile(filePath);
        return file.getClass(className);
    }
}
exports.AbsApiClass = AbsApiClass;
//# sourceMappingURL=AbsApiClass.js.map